@echo OFF

REM Script to apply patches from qt-copy/patches/
REM See README.qt-copy for details.
REM This is only a basic version without any advanced functionality.
REM
REM Bernhard Loos <nhuh.put@web.de>

cd ..

SETLOCAL ENABLEDELAYEDEXPANSION

IF "%1%" EQU "/nopause" (
    SET NOPAUSE=true
) ELSE IF "%1%" NEQ "" (
    echo invalid commmand line argument
    GOTO END
)


IF NOT EXIST patches (
    echo "patch directory not found"
    GOTO END
)

IF EXIST qtwin_patch\patch.exe (
    SET PATCH=qtwin_patch\patch.exe
) ELSE (
    SET PATCH=patch.exe
)

IF EXIST .svn (
    SET FILE_LIST=`findstr /M /C:"applied: no" patches\*.diff`
) ELSE (
    SET FILE_LIST=patches\*.diff
)

FOR /F "usebackq" %%f IN (%FILE_LIST%) DO (
    SET PNUM=
    FOR /F "delims=\-; tokens=2" %%i IN ("%%f") DO (
        SET PNUM=%%i
    )
    SET ERRORLEVEL=
    findstr /X /R /C:"^ *!PNUM! *$" ".applied_patches" > nul
    IF !ERRORLEVEL! EQU 1 (
        echo Applying: %%f
        %PATCH% -f --binary -p0 < %%f
        echo !PNUM!>> ".applied_patches"
    )
)

echo done
:END
IF "%NOPAUSE%" NEQ "true" (
    pause
)
